#version 410

out vec4 FragColor;

in vec3 worldPos;
in vec3 worldNormal;

uniform vec3 m_lightPos0; //world space, directional light
uniform vec3 m_lightColor0; 
uniform vec4 m_color;
uniform float m_opacity;

void main()
{    
    float ambientStrength = 0.6;  // ambient
    vec3 ambient = ambientStrength * m_lightColor0;

    float diffStrength = 0.7;
    vec3 norm = normalize(worldNormal);  // diffuse 
    vec3 lightDir = normalize(m_lightPos0); // normalize(m_lightPos - worldPos); 
    float diff = max(dot(norm, lightDir), 0.0);
    vec3 diffuse = diffStrength * diff * m_lightColor0;

    vec3 result = (ambient + diffuse) * m_color.rgb;
    FragColor = clamp(vec4(result, m_opacity), 0.0, 1.0);
}
