#version 410

out vec4 FragColor;

in vec3 worldPos;
in vec3 worldNormal;
in vec2 uv_MainTex;

uniform vec3 m_lightPos0; //world space, directional light
uniform vec3 m_lightColor0; 
uniform vec4 m_color;

uniform sampler2D _Diffuse_Map0;
uniform bool is_Diffuse_Map0;

void main()
{
    vec4 textColor = vec4(1,1,1,1);
    if(is_Diffuse_Map0){   
        textColor = texture(_Diffuse_Map0, uv_MainTex);
        if(textColor.r < 0.7)  //black cutout
            discard;
    }
    float ambientStrength = 0.6;  // ambient
    vec3 ambient = ambientStrength * m_lightColor0;

    float diffStrength = 0.7;
    vec3 norm = normalize(worldNormal);  // diffuse 
    vec3 lightDir = normalize(m_lightPos0); // normalize(m_lightPos - worldPos); 
    float diff = abs(dot(norm, lightDir));
    vec3 diffuse = diffStrength * diff * m_lightColor0;

    vec3 result = (ambient + diffuse) * m_color.rgb;
    FragColor = clamp(vec4(result, m_color.a), 0.0, 1.0);
}
