#version 410

layout (location = 0) in vec3 aPos;
layout (location = 2) in vec3 aNormal;

out vec3 worldNormal;
out vec3 cameraNormal;

uniform mat4 m_matrix;   //projection * view * model
uniform mat4 m_viewMatrix;  //view
uniform mat4 m_model;  // model

void main()
{
    gl_Position = m_matrix * vec4(aPos, 1.0);

    worldNormal = mat3(transpose(inverse(m_model))) * aNormal;
    cameraNormal = mat3(transpose(inverse(m_viewMatrix)))  * worldNormal;
}
