#version 410

layout (location = 0) in vec3 aPos;
layout (location = 1) in vec2 v2TexCoordsIn;
layout (location = 2) in vec3 aNormal; //vertice normal
layout (location = 3) in vec3 aTangent;
layout (location = 4) in vec3 aBitangent;

out vec3 worldPos;
out vec2 uv_MainTex;
out vec3 worldNormal;
out vec3 worldTangent;
out vec3 worldBiTangent;
out vec4 lightSpacePos0;
out vec4 lightSpacePos1;

uniform mat4 m_matrix;   //projection * view * model
uniform mat4 m_model;
uniform mat4 m_lightSpaceMatrix0;
uniform mat4 m_lightSpaceMatrix1;

void main()
{
    uv_MainTex = v2TexCoordsIn;
    gl_Position = m_matrix * vec4(aPos, 1.0);
    worldPos = vec3(m_model * vec4(aPos, 1.0));
    worldNormal = mat3(transpose(inverse(m_model))) * aNormal;
    worldTangent = mat3(m_model) * aTangent;
    worldBiTangent = mat3(m_model) * aBitangent;

    lightSpacePos0 = m_lightSpaceMatrix0 * vec4(worldPos, 1.0);
    lightSpacePos1 = m_lightSpaceMatrix1 * vec4(worldPos, 1.0);
}
