#version 410

layout (location = 0) in vec3 aPos;
layout (location = 1) in vec2 v2TexCoordsIn;
layout (location = 2) in vec3 aNormal;
layout (location = 3) in vec3 aTangent;
//layout (location = 5) in vec3 aColor;
layout (location = 6) in float aWeight;

out vec3 worldPos;
out vec3 worldNormal;
out vec2 uv_MainTex;
out vec3 worldTangent;
out vec4 lightSpacePos;
//out vec3 vColor;
out float lightWeight;

uniform mat4 m_matrix;   //projection * view * model
uniform mat4 m_model;
uniform mat4 m_lightSpaceMatrix0;

void main()
{
    uv_MainTex = v2TexCoordsIn;
    gl_Position = m_matrix * vec4(aPos, 1.0);
    worldPos = vec3(m_model * vec4(aPos, 1.0));
    worldNormal = mat3(transpose(inverse(m_model))) * aNormal;
    worldTangent = mat3(m_model) * aTangent;

    lightSpacePos = m_lightSpaceMatrix0 * vec4(worldPos, 1.0);
    //vColor = aColor;
    lightWeight = aWeight;

    //depth = gl_Position.zw;
}
